/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks of the Open-Xchange, Inc. group of companies.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2004-2014 Open-Xchange, Inc.
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
package com.openexchange.guard.cacheitems;

import java.util.concurrent.ConcurrentHashMap;

/**
 * Holds data for this server. Everything should be thread safe. To be used ONLY for speed. All data should not be dependent on a specific
 * machine, and should allow clustering
 * 
 * @author greg
 */
public class Cache {

	
    // Data from the configDB. Store after initial lookup.
    private static ConcurrentHashMap<Integer, ContextToDatabase> contextInfo = new ConcurrentHashMap<Integer, ContextToDatabase>();;

    private static ConcurrentHashMap<Integer, ContextToDatabase> readcontextInfo = new ConcurrentHashMap<Integer, ContextToDatabase>();

    // That the OxGuard tables have been added to the database
    private static ConcurrentHashMap<String, Boolean> initialized = new ConcurrentHashMap<String, Boolean>();


    public static ContextToDatabase getContext(int context, boolean readonly) {
        if (readonly) {
            if (readcontextInfo.containsKey(context)) {
                return (readcontextInfo.get(context));
            } else
                return (null);
        }
        if (contextInfo.containsKey(context)) {
            return (contextInfo.get(context));
        } else
            return (null);
    }

    public static void saveContext(int context, String url, String database, String username, String password, int DBPool, boolean readonly) {
        ContextToDatabase item = new ContextToDatabase(url, database, username, password, DBPool);
        if (readonly) {
            readcontextInfo.put(context, item);
        } else {
            contextInfo.put(context, item);
		}
    }

    public static boolean isInitialized(String database) {
        if (initialized.containsKey(database)) {
            return (initialized.get(database));
        } else
            return (false);
    }

    public static void saveInitialized(String database) {
    }

}
