Name:          open-xchange-guard
BuildArch:     noarch
#!BuildIgnore: post-build-checks
BuildRequires: ant-nodeps
%if 0%{?fedora_version} || 0%{?rhel_version}
BuildRequires: java7-devel
%endif
%if 0%{?suse_version}
BuildRequires: java-devel >= 1.7.0
%endif
Version:       1.2.0
%define        ox_release 4
Release:       %{ox_release}_<CI_CNT>.<B_CNT>
Group:         Applications/Productivity
License:       GPL-2.0
BuildRoot:     %{_tmppath}/%{name}-%{version}-build
URL:           http://www.open-xchange.com/
Source:        %{name}_%{version}.orig.tar.bz2
Source1:       open-xchange-guard.init
Summary:       Open-Xchange Guard micro service
Requires:      jre >= 1.7.0
%if 0%{?fedora_version} || 0%{?rhel_version}
Requires:      redhat-lsb
%endif

%description
Guard - the Open-Xchange security solution. This package contains the Guard backend component.

Authors:
--------
    Open-Xchange

%prep

%setup -q

%build

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
ant -Dbasedir=build -DdestDir=%{buildroot} -DpackageName=%{name} -f build/build.xml clean build
mkdir -p %{buildroot}/var/log/open-xchange/guard
mkdir -p %{buildroot}/var/spool/open-xchange/guard/uploads
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/sbin
install -m 755 %{SOURCE1} %{buildroot}/etc/init.d/open-xchange-guard
ln -sf ../etc/init.d/open-xchange-guard %{buildroot}/sbin/rcopen-xchange-guard

%post
if [ ${1:-0} -eq 2 ]; then
    # only when updating
    . /opt/open-xchange/guard/sbin/oxfunctions.sh

    # prevent bash from expanding, see bug 13316
    GLOBIGNORE='*'

    # SoftwareChange_Request-2182
    # -----------------------------------------------------------------------
    pfile=/opt/open-xchange/guard/etc/guard.properties
    if ox_exists_property com.openexchange.guard.logType $pfile; then
        ox_remove_property com.openexchange.guard.logType $pfile
    fi
    
    # SoftwareChange_Request-2183
    # -----------------------------------------------------------------------
	prefix="com.openexchange.guard."
    declare -a props
    declare -a propKeys=('SSLPort' 'SSLKeyStore' 'SSLKeyName' 'SSLKeyPass');
    declare -a defaults=('8443' '//keystore location//' '//alias name here//' '//ssl password//');

    prop="com.openexchange.guard.useSSL"
    if ox_exists_property $prop $pfile; then
        useSSL=$(ox_read_property $prop $pfile)
    else
        ox_comment $prop remove $pfile
    fi

    for prop in ${propKeys[@]}; do
        p=$prefix$prop
        if ox_exists_property $p $pfile; then
            VALUE=$(ox_read_property $p $pfile)
            props=("${props[@]}" "$VALUE")
        else
            ox_comment $p remove $pfile
        fi
        ox_remove_property $p $pfile
    done

    sed -i 's/com.openexchange.guard.useSSL:.*/# com.openexchange.backend_SSL=true/g' $pfile

    prop="com.openexchange.guard.useSSL"
    commented=false
    if [[ -z "$useSSL" ]]; then
        useSSL="true"
        commented=""
    fi
    ox_set_property $prop "$useSSL" $pfile
    if [[ -z "$commented" ]]; then
        ox_comment $prop add $pfile
    fi
    
    index=0;
    for prop in ${propKeys[@]}; do
        p=$prefix$prop
        commented=false
        value=${props[$index]}
        if [[ -z "$value" ]]; then
            value=${defaults[$index]}
            commented=""
        fi
        ox_set_property $p "$value" $pfile
        if [[ -z "$commented" ]]; then
            ox_comment $p add $pfile
        fi
        ((index++))
    done
fi

%pre
/usr/sbin/groupadd -r open-xchange 2> /dev/null || :
/usr/sbin/useradd -r -g open-xchange -r -s /bin/false -c "open-xchange system user" -d /opt/open-xchange open-xchange 2> /dev/null || :


%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
/opt/open-xchange/guard/*
%config(noreplace) %attr(640, root, open-xchange) /opt/open-xchange/guard/etc/*
%dir %attr(750, open-xchange, root) /var/log/open-xchange/guard
%dir %attr(750, open-xchange, root) /var/spool/open-xchange/guard/uploads
/etc/init.d/open-xchange-guard
/sbin/rcopen-xchange-guard

%changelog
* Wed Jan 07 2015 Greg Hill <greg.hill@open-xchange.com>
Fourth candidate for 1.2.0 release
* Sun Jan 04 2015 Greg Hill <greg.hill@open-xchange.com>
Third candidate for 1.2.0 release
* Wed Dec 10 2014 Greg Hill <greg.hill@open-xchange.com>
Second candidate for 1.2.0 release
* Thu Oct 30 2014 Greg Hill <greg.hill@open-xchange.com>
Build for 1.2
* Wed Sep 03 2014 Marcus Klein <marcus.klein@open-xchange.com>
Third candidate for 1.0.0 release
* Tue Sep 02 2014 Marcus Klein <marcus.klein@open-xchange.com>
Second candidate for 1.0.0 release
* Thu Aug 28 2014 Marcus Klein <marcus.klein@open-xchange.com>
First candidate for 1.0.0 release
* Thu Aug 28 2014 Marcus Klein <marcus.klein@open-xchange.com>
prepare for 1.0.0
